
% Introduzione a matlab


% (1) Preliminari
%%%%%%%%%%%%%%%%%%%%%%

% Il simbolo "%" e' usato davanti a un commento.

% Per invocare aiuto "help" (produce una lista di help topic) oppure "help argomento"

% Se non si conosce il nome esatto del  topic o del comando,
% digitaer "lookfor parola chiave" (e.g., "lookfor regression")

% Se scriviamo uno statement lungo  usare ...
% per continuare sulla prossima riga.

% Quando si scrive una linea di comando, un ";" a fine linea impedisce a matlab
% di visualizzare il risultato. Se ";" viene omesso matlab visualizza il risultato.





% (2) Oggetti in matlab --  scalari,
% vettori,  matrici...
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Definire uno scalare

%  Definire un vettore riga
disp('Definire un vettore riga...')
v = [1 0 0]
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')
%  Definire un vettore colonna
disp('Definire un vettore colonna...')
v = [1;2;3]

disp('Premere un tasto per continuare...')
pause
disp('____________________________________')
%  Trasposta di un vettore (riga-> colonna o colonna -> riga)
disp('Trasposta di un vettore...')
v = v'

disp('Premere un tasto per continuare...')
pause
disp('____________________________________')
%    Definire un vettore in un cero range: v=start:stepsize:end
disp('Definire un vettore in un cero range: v=start:stepsize:end...')
v=1:.5:3
V=pi*[-4:4]/4

disp('Premere un tasto per continuare...')
pause
disp('____________________________________')
% Definire un vettore vuoto (empty)
disp('Definire un vettore vuoto...')
v=[]
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')
%  Definire una matrice 
disp('Definire una matrice...')
m = [1 2 3; 4 5 6]
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')
%  matrici in matlab;               1o parametro indice di riga (ROWS)
%                                   2o parametro indice di colonna (COLS) 
%  Definire una matrice/vettore di zeri/uno
disp('Definire una matrice di zeri...')
m=zeros(2,3)  
disp('Definire un vettore di uno...')
v=ones(1,3)  
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')
%  Definire una matrice identita'
disp('Definire una matrice identita...')
m=eye(3)
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')
%Definire una matrice random : (rand, randn)
disp('Definire una matrice random...')
v=rand(3,1) 
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')
% Leggere dati da un file:
% Creare un file di nome matrix_data del tipo: 
% 2     3     4
% 5     6     7
% 1     2     3
disp('Leggere dati da un file...')
load matrix_data 
matrix_data
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')
% Accesso mediante indice all'elemento di un vettore/matrice: vettore(indice)o matrice(indiceriga, indicecolonna)
disp('Accesso mediante indice a elemento di un vettore...')
v=[1 2 3]
v(3)
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')
disp('Accesso mediante indice a elemento di matrice...')
m=[1 2 3; 4 5 6]
m(1,3)              %1a riga, 3a colonna
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')
% Accesso mediante riga/ colonna a una matrice: matrice(indiceriga,:) matrice(:,indicecolonna)
% : rappresenta tutti i valori in quella riga/colonna, oppure si puo' specificare un range di valori.
disp('Accesso mediante riga/ colonna a una matrice...')
disp('...visualizza tutta la riga 2 ...')
m(2,:)    %2a riga
disp('...visualizza tutta la colonna 1 ...')

m(:,1)    %1a colonna
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')
disp('...visualizza la riga 2 da colonna 1 a 2 ...')
m
m(2,1:2)
m(1:2, 1:2)
disp('...visualizza la sottomatrice da riga 1 a 2 da colonna 1 a 2 ...')
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')
% dimensione di una matrice
disp('dimensione di una matrice...')
size(m)
disp('numero righe...')
size(m,1)  %num righe
disp('numero colonne...')
size(m,2)  %num colonne
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')
% crea un nuovo vettori di zeri con la stessa dimensione di m

disp('crea un nuovo vettori di zeri di dimensoni pari a m...')
m1=zeros(size(m))
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')
% quali oggetti/variabili abbiamo definito? "who" oppure "whos"
disp('quali oggetti/variabili abbiamo definito?...')
who
whos
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')
% (3) Semplici operazioni su vettori o matrici
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% (A)  Operazioni puntuali (Pointwise):
disp('Operazioni puntuali (Pointwise)...')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% somma di vettori/matrici e moltiplicazione per uno scalare
% sono effettuati "elemento per elemento"
disp(' moltiplicazione per uno scalare...')
a=[1 2 3 4]
2*a
a/4
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')
disp('somma di vettori/matrici ...')
b=[5 6 7 8]
a+b
a-b
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')
% Ma  * / ^ sono operazioni matriciali e non operano "elemento per elemento". 
% Per renderle puntuali, usare un "." di fronte agli operatori: .* ./ .^
disp('* / ^ sono operazioni matriciali e non operano pointwise...')
point_sqrd = a .^2
point_mult= a.*b
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')
% Matlab ha un ampio numero di funzioni built in.
% Alcune operano puntuamente sugli elementi di vettori/matrici:
disp('Funzioni built in pointwise...')
log([1 2 3 4])
round([1.5 2; 2.2 3.1])
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')
% (B) Operazioni vettoriali
disp('Operazioni vettoriali...')
%%%%%%%%%%%%%%%%%%%%%%%

% Funzioni matlab Built-in  functions che operano su un vettore. Se al posto di un vettore abbiamo una matrice, 
% allora operano su ogni colonna della matrice. Esempi:

a=[1 4 6 3]
disp('Somma...')
sum(a)
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')
disp('Media...')
mean(a)
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')
disp('Varianza...')
var(a)
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')
disp('Deviazione standard...')
std(a)
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')
disp('Massimo...')
max(a)
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')
disp('Operazioni vettoriali su matrici...')
a=[1 2 3; 4 5 6]
disp('media di ciascuna colonna...')
mean(a)                      %media di ciascuna colonna
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')
disp('max di ciascuna colonna...')
max(a)                       %max di ciascuna colonna 
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')
disp('max ditutta la matrice...')
max(max([1 2 3; 4 5 6]))     %max ditutta la matrice
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')

% (C) Operazioni matriciali:
%%%%%%%%%%%%%%%%%%%%%%%%
disp('Operazioni matriciali...')

% moltiplicazione di matrici
% assicurarsi che le dimensioni siano consistenti:  (i j) * (j k)
disp('Prodotti...')
% disp('questo per esempio e'' un errore......')
% [1 2 3]  * [4 5 6]  % questo per esempio e' un errore...
% size([1 2 3])
% size([4 5 6])
% disp('Premere un tasto per continuare...')
% pause

disp('Prodotto scalare...')
[1 2 3] * [4 5 6]'  % vettore riga 1x3 e  vettore colonna 3x1 
                    % il risultato e' uno scalare (ovvero il prodotto scalare o prodotto interno).
disp('Premere un tasto per continuare...')
pause 
disp('____________________________________')
disp('prodotto esterno di  2 vettori...')
v1=[1 2 3]
v2=[4 5 6]

v1' * v2  % vettore colonna 3x1 e  vettore riga 1x3
                    % produce una matrice  3x3 .
                    % detto outer product o prodotto esterno di  2 vettori.
disp('Premere un tasto per continuare...')
pause 
disp('...')
v2' * v1
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')
disp('Prodotto matrice vettore...')
a=[1 2; 3 4; 5 6]
b=[5 6 7];
size(a)
size(b)
b*a
size(b*a)
a'*b'
size(a'*b')
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')

%(4) Salvare la sessione di lavoro
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Si possono salvare tutte o alcune  variabili definite durante la sessione di lavoro

disp('Salvare la sessione di lavoro...')
save mysession      %crea un file di nome session.mat con tutte le variabili
disp('crea un file di nome session.mat con tutte le variabili...')
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')

disp('salva solo le variabili a e b...')
save mysession a b  %salva solo le variabili a e b
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')

disp('elimina le variabili a  b da ambiente di lavoro...')
clear a b           %elimina le variabili a  b dall'ambiente di lavoro
disp('Premere un tasto per continuare...')
pause
% Per caricare la sessione
disp('Per caricare la sessione...')
load mysession
a
b
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')
%(5) Operatori relazionali e statement di controllo
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Operatori relazionali: == (equal), ~= (not equal), <, <=, >, >=, etc.

% Strutture condizionali:
%
% if condizione1
%   ...
% elseif condizione2
%   ...
% else
%   ...
% end
disp('Strutture condizionali...')
x=2
y=3
z=5
if x>y
  fprintf('risultato: x=%d\n',x)
elseif y>z
  fprintf('risultato: y=%d\n',y)
else
  fprintf('risultato: z=%d\n',z)
end
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')

% Cicli controllati da un contatore:
% 
% for i = limite1:passo:limite2
% ...
% end
disp('Cicli controllati da un contatore: for...')
for i = 1:10
    fprintf('i=%d ',i);
end
fprintf('\n');
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')

% Cicli controllati da una condizione
% 
% while condizione1
%   ...
% end
disp('Cicli controllati da una condizione: while...')
i=1;
while (i<=10)
  fprintf('i=%d ',i);
  i=i+1;
end
fprintf('\n');
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')

% Esempio: dato un vettore vec,creare un nuovo vettore con valori uguali a
% vec se  sono >  0, e uguali a 0 se sono <= 0.
disp('Esempio: dato un vettore vec,creare un nuovo vettore con valori uguali a')
disp('vec se  sono >  0, e uguali a 0 se sono <= 0.')
vec=[3 5 -2 5 -1 0]

% metodo classico: ciclo di iterazione
disp('metodo classico: ciclo di iterazione...')
new_vec=zeros(size(vec));        %inizializza a zero il nuovo vettore
for i=1:size(vec,2)
   if vec(i)>0 
	new_vec(i)=vec(i); 
   end
end
new_vec

disp('Premere un tasto per continuare...')
pause
disp('____________________________________')

% stile matlab: possiamo evitare il ciclo di iterazione  usando funzioni specifiche di matlab 
disp('stile matlab: eliminazione dei cicli...')
new_vec2=zeros(size(vec));
tmp=find(vec>0)       %restituisce gli  indici di tutti i valori del vettore diversi da  0
new_vec2(tmp)=vec(tmp)

disp('Premere un tasto per continuare...')
pause
disp('____________________________________')
disp('Creare funzioni  usando m-files')

%(6) Creare funzioni  usando m-files:
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Le funzioni in matlab sono scritte in m-files. aprire un M-FILE di nome 
% "thres.m" Scrivere nell' m-file il seguente codice: 

% function res=thres(inp)
% 
% res=zeros(size(inp));
% tmp=find(inp>0)       %restituisce gli  indici di tutti i valori del vettore diversi da  0
% res(tmp)=inp(tmp)


% res e' il valore di ritorno della funzione, e inp il parametro
% passato alla funzione. Si puo' utilizzare qualsiasi nome...


% dalla linea di comando: chiamiamo la funzione thres passando qualsiasi matrice o vettore:
disp('chiamiamo la funzione thres...')
thres(vec)
disp('Premere un tasto per continuare...')
pause
thres([-5 5 5; 4 5 -1])
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')


%(7) Un po' di plotting
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% plotting di vettori:
disp('plotting di vettori...')
x=[0 1 2 3 4];
plot(x);
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')
plot(x,2*x);
axis([0 8 0 8])
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')
x=pi*[-24:24]/24;
plot(sin(x));
plot(x,sin(x));
xlabel('radianti');
ylabel('valore del seno');
title('dummy');
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')
% molti grafici  in un unico plot:
close all

disp('molti grafici  in un unica figura:...')
figure               %apre una nuova figura
subplot(1,2,1);
plot(x,sin(x));
subplot(1,2,2);
plot(x,2.*cos(x));
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')

disp('sovrapporre due grafici in un unico plot...')
clf
figure

plot(x,sin(x));
hold on              %usare hold off per rilasciare hold           
plot(x,2.*cos(x),'--');
legend('sin', 'cos');
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')
% usare semilog

disp('usare semilog...')
clf
figure
x=-5:.25:5;
subplot(1,2,1)
plot(x,exp(x));
subplot(1,2,2)
semilogy(x,exp(x))
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% (8) Lavorare con  Immagini e il Matlab Image Processing Toolbox
disp('Lavorare con  Immagini e il Matlab Image Processing Toolbox...')
close all

disp('legge un''immagine JPEG in una matrice...')
I=imread('rugby.jpg');		% legge un'immagine JPEG in una matrice 3D 

figure(1)
disp('visualizza l''immagine...')
imshow(I)
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')

disp('Seleziona un rettangolo con il mouse...')
rect=getrect;				% Seleziona un rettangolo con il mouse. Poi:
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')

disp('effettua il crop e la converte a livelli di grigio...')
I2=imcrop(I,rect);			% crop
I2=rgb2gray(I2);			% converte a livelli di grigio 
max(I2(:))                  % intensita massima in I2
min(I2(:))                  % intensita minima in I2
colormap(gray(256));		% usa una gray colormap per valori 0-255
disp('visualizza il risultato...')

image(I2)                   % display immagine
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')

disp('scala i dati per usare tutta la colormap...')
imagesc(I2)                 % scala i dati per usare tutta la colormap
                            %  tra valori di min e max in I2
                            %          min = nero, max = bianco
                            
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')

disp('attiva una color bar...')
colorbar                    % attiva una color bar
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')


disp('Premere un tasto per continuare...')
pause
disp('display alla risoluzione di un pixel del  monitor...')
truesize                    % display alla risoluzione di un pixel del  monitor
                            %  per image pixel
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')
disp('display alla risoluzione di un pixel del  monitor...')
truesize(2*size(I2))		% display alla risoluzione di  due pixel del  monitor
                            %  per image pixel
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')

disp('resize del 50% utilizzando bilineare interpolation...')
I3=imresize(I2,0.5,'bil');          % resize del 50% utilizzando bilineare interpolation
imagesc(I3)
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')

disp('ruota di 45 gradi e  crop alla dimensione originale...')
I3=imrotate(I2,45,'bil','crop');	% ruota di 45 gradi e  crop alla dimensione originale
imagesc(I3)
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')

disp('converte da uint8 a double, per consentire operazioni matematiche:')
disp('quadrato delle intensita'' dell''immagine (pixel-wise)...')

I3=double(I2);				% converte da uint8 a double, per consentire
                            %  operazioni matematiche
imagesc(I3.^2)				% display del quadrato delle intensita dell'immagine (pixel-wise)
disp('Premere un tasto per continuare...')
pause
disp('____________________________________')

disp('log delle intensita'' dell''immagine (pixel-wise)...')
imagesc(log(I3))			% display del log delle intensita dell'immagine

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

